#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define en '\n'
#define sp ' '
#define ri(x) int x; cin >> x;
#define smax(a, b) a = max(a, b)
#define smin(a, b) a = min(a, b)

using namespace std;

const ll LINF = 2e18;
const int mxN = 3e3+10, INF = 2e9;
ll n, m, depth[mxN], par[mxN], mx[mxN];
vector<int> g[mxN];
bool on_diam[mxN];

array<int, 2> dfs(int s, int p = -1, int d = 0){

    par[s] = p;
    depth[s] = d;
    array<int, 2> t = {d, s};
    for (int u : g[s]){
        if (u^p){
            auto e = dfs(u, s, d+1);
            if (e[0] > t[0]) t = e;
        }
    }
    mx[s] = t[0];
    return t;
}

vector<int> Get(int s){

    if (!~par[s]) return {s};
    auto v = Get(par[s]);
    v.pb(s);
    return v;
}

vector<int> FindDiameter(){

    for (int i = 0; i < n; i++)
        on_diam[i] = 0;
    auto mx = dfs(0);
    mx = dfs(mx[1]);
    vector<int> v = Get(mx[1]);
    for (int s : v) on_diam[s] = 1;
    return v;
}

void Edge(int u, int v){ g[u].pb(v); g[v].pb(u); }

void Solve(){

    cin >> n >> m;
    for (int i = 0; i < n-1; i++){
        ri(u); ri(v);
        u--; v--;
        Edge(u, v);
    }
    while (m--){
        auto nodes = FindDiameter();
        if (nodes.size() == n) break;
        array<int, 2> t = {0, -1};
        for (int s = 0; s < n; s++){
            if (!on_diam[s]){
                int d = mx[s] - depth[s] + 1;
                if (d > t[0]) t = {d, s};
            }
        }
        for (int i = 0; i < n; i++)
            g[i].clear();
        for (int s = 0; s < n; s++)
            if (s != nodes[0] && s != t[1])
                Edge(s, par[s]);
        Edge(t[1], nodes[0]);
    }
    cout << FindDiameter().size()-1 << en;
    for (int i = 0; i < n; i++)
        g[i].clear();
}

int main(){

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0); cerr.tie(0);

    int t = 1;
    cin >> t;
    while (t--)
        Solve();
    return 0;
}