#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define en '\n'
#define sp ' '
#define ri(x) int x; cin >> x;
#define smax(a, b) a = max(a, b)
#define smin(a, b) a = min(a, b)

using namespace std;

const ll LINF = 2e18;
const int mxN = 3e3+10, INF = 2e9;
ll n, m, par[mxN], par1[mxN];
vector<int> g[mxN];

array<int, 2> dfs(int s, int p = -1, int d = 0){

    par[s] = p;
    array<int, 2> t = {d, s};
    for (int u : g[s]){
        if (u^p){
            auto e = dfs(u, s, d+1);
            if (e[0] > t[0]) t = e;
        }
    }
    return t;
}

vector<int> Get(int s){

    if (!~par[s]) return {s};
    auto v = Get(par[s]);
    v.pb(s);
    return v;
}

vector<int> FindDiameter(int root = 0){

    auto mx = dfs(root);
    mx = dfs(mx[1]);
    return Get(mx[1]);
}

void Edge(int u, int v){ g[u].pb(v); g[v].pb(u); }

void Delete(int s){

    for (int i = 0; i < n; i++)
        g[i].clear();
    for (int i = 0; i < n; i++)
        if (~par1[i] && i^s) Edge(i, par1[i]);
}

void Par(int s, int p = -1){

    par1[s] = p;
    for (int u : g[s])
        if (u^p) Par(u, s);
}

void Solve(){

    cin >> n >> m;
    for (int i = 0; i < n-1; i++){
        ri(u); ri(v);
        u--; v--;
        Edge(u, v);
    }
    while (m--){
        Par(0);
        array<int, 3> mx = {0, 0, -1};
        for (int s = 1; s < n; s++){
            Delete(s);
            vector<int> v1 = FindDiameter(), v2 = FindDiameter(s);
            int d = v1.size() + v2.size();
            int cnt = -2;
            for (int i = 0; i < n; i++)
                if (g[i].size() == 1) cnt++;
            if (d > mx[0] || (d == mx[0] && cnt < mx[1])) mx = {d, cnt, s};
            Edge(s, par1[s]);
        }
        Delete(mx[2]);
        vector<int> v1 = FindDiameter(), v2 = FindDiameter(mx[2]);
        Edge(v1[0], v2[0]);
        if (mx[0] == n) break;
    }
    cout << FindDiameter().size()-1 << en;
    for (int i = 0; i < n; i++)
        g[i].clear();
}

int main(){

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0); cerr.tie(0);

    int t = 1;
    cin >> t;
    while (t--)
        Solve();
    return 0;
}