#include <bits/stdc++.h>

#define ll long long
#define pb push_back
#define en '\n'
#define sp ' '
#define all(v) v.begin(), v.end()
#define ri(x) int x; cin >> x;
#define smax(a, b) a = max(a, b)
#define smin(a, b) a = min(a, b)
#define pv(v) for (auto x : v) cout << x << sp; cout << en;

using namespace std;

const ll LINF = 2e18;
const int mxN = 3e3+10, INF = 2e9;
ll n, m, dp[mxN], depth[mxN], par[mxN];
vector<int> g[mxN];
vector<array<int, 2> > len[mxN];
bool vis[mxN];

array<int, 2> dfs(int s, int p = -1, int d = 0){

    depth[s] = d;
    par[s] = p;
    array<int, 2> t = {d, s};
    for (int u : g[s]){
        if (u^p){
            auto e = dfs(u, s, d+1);
            if (e[0] > t[0]) t = e;
        }
    }
    return t;
}

vector<int> Get(int s){

    if (!~par[s]) return {s};
    auto v = Get(par[s]);
    v.pb(s);
    return v;
}

vector<int> FindDiameter(int root = 0){

    for (int i = 0; i < n; i++)
        vis[i] = 0;
    auto mx = dfs(root);
    mx = dfs(mx[1]);
    auto v = Get(mx[1]);
    for (int x : v) vis[x] = 1;
    return v;
}

void Edge(int u, int v){ g[u].pb(v); g[v].pb(u); }

int DP(int s, int p = -1){

    len[s].clear();
    for (int u : g[s]){
        if (u^p){
            int d = DP(u, s);
            len[s].pb({d, u});
        }
    }
    sort(all(len[s])); reverse(all(len[s]));
    while (len[s].size() < 3) len[s].pb({0, -1});
    dp[s] = len[s][0][0] + 1 + len[s][1][0];
    return len[s][0][0]+1;
}

void Solve(){

    cin >> n >> m;
    for (int i = 0; i < n-1; i++){
        ri(u); ri(v);
        u--; v--;
        Edge(u, v);
    }
    while (m--){
        auto nodes = FindDiameter();
        DP(nodes[0]);
        array<int, 3> cur = {0, 0, -1};
        for (int s : nodes){
            if (~par[s]){
                int d = dp[s] + depth[par[s]];
                if (len[par[s]][0][1] != s) d += len[par[s]][0][0];
                else d += len[par[s]][1][0];
                int cnt = -2;
                if (g[s].size() < 3) cnt++;
                if (g[par[s]].size() < 3) cnt++;
                if (d > cur[0] || (d == cur[0] && cnt < cur[1]))
                    cur = {d, cnt, s};

                for (int u : g[s]){
                    if (!vis[u]){
                        d = dp[u] + nodes.size();
                        cnt = -2;
                        if (g[u].size() < 3) cnt++;
                        if (d > cur[0] || (d == cur[0] && cnt < cur[1]))
                            cur = {d, cnt, u};
                    }
                }
            }
        }
        for (int i = 0; i < n; i++)
            g[i].clear();
        for (int i = 0; i < n; i++)
            if (~par[i] && i != cur[2]) Edge(i, par[i]);
        vector<int> v1 = FindDiameter(nodes[0]), v2 = FindDiameter(cur[2]);
        Edge(v1[0], v2[0]);
    }
    cout << FindDiameter().size()-1 << en;
    for (int i = 0; i < n; i++)
        g[i].clear();
}

int main(){

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0); cerr.tie(0);

    int t = 1;
    cin >> t;
    while (t--)
        Solve();
    return 0;
}