#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define pb push_back
#define en '\n'
#define sp ' '
#define ri(x) int x; cin >> x;
#define rl(x) ll x; cin >> x;
#define rs(x) string x; cin >> x;
#define pv(v) for (auto x : v) cout << x << sp; cout << en;
#define all(v) v.begin(), v.end()
#define smax(a, b) a = max(a, b)
#define smin(a, b) a = min(a, b)
#define bitcnt(a) (__builtin_popcntll(a))
#define lg(a) (63-__builtin_clzll(a))
#define highpow(a) (1LL << lg(a))

using namespace std;

class BIT{

    int n;
    vector<int> tree;

    int query(int pos) const {

        smin(pos, n);
        int sum = 0;
        for (; pos; pos -= (pos & -pos))
            sum += tree[pos];
        return sum;
    }

public:
    void Assign(int s){ n = s; tree.assign(s+1, 0); }
    void update(int pos, int x){
        pos++;
        if (pos < 1) return;
        for (; pos <= n; pos += (pos & -pos))
            tree[pos] += x;
    }
    int query(int l, int r) const {
        l++; r++;
        if (l > r) return 0;
        return query(r) - query(l-1);
    }
};

const ll LINF = 2e18;
const int mxN = 1e6+10, INF = 2e9;
ll n, m, a[mxN];
BIT fen[20];

int BS(int j, int i){

    int l = i+1, r = n-1, ans = n;
    while (l <= r){
        int k = (l + r + 1)>>1;
        if (fen[j].query(i+1, k) < k-i){
            ans = k;
            r = k - 1;
        }
        else l = k + 1;
    }
    return ans;
}

void Set(int j, int i, int x){

    if (x) x = 1;
    int y = fen[j].query(i, i);
    fen[j].update(i, x-y);
}

int query(int i, int mask){

    int r = i;
    for (int j = 0; j < 20; j++){
        if (mask & (1<<j)){
            int k = BS(j, i);
            smax(r, k);
        }
    }
    return r;
}

void Solve(){

    cin >> n;
    for (int i = 0; i < n; i++)
        cin >> a[i];
    for (int j = 0; j < 20; j++){
        fen[j].Assign(n);
        for (int i = 0; i < n; i++)
            Set(j, i, (a[i]&(1<<j)));
    }
    cin >> m;
    while (m--){
        ri(c); ri(i);
        c--; i--;
        if (c){
            int x = a[i], ans = INF;
            for (int l = i; ~l; l--){
                x = (x&a[l]);
                if (!x){
                    smin(ans, i-l);
                    break;
                }
                int r = query(i, x);
                if (r < n) smin(ans, i-l + r-l);
            }
            if (ans == INF) ans = -1;
            cout << ans << en;
        }
        else{
            ri(x);
            for (int j = 0; j < 20; j++)
                Set(j, i, (x&(1<<j)));
            a[i] = x;
        }
    }
}

int main(){

    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0); cerr.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        Solve();
    return 0;
}