#include <bits/stdc++.h>
using namespace std;

const int MAXN = 3003;
set<int> g[MAXN];

int udaljenost_najdaljeg;
int najdalji;

void dfs1(int x, int prev, int d)
{
    if (prev == -1) {
        udaljenost_najdaljeg = INT_MIN;
        najdalji = -1;
    }
    //cout << x << " " << prev << " " << d << endl;
    if (d > udaljenost_najdaljeg)
    {
        udaljenost_najdaljeg = d;
        najdalji = x;
    }

    for (auto a: g[x])
    {
        if (a != prev)
        {
            dfs1(a, x, d + 1);
        }
    }
}

struct CvorInfo
{
    bool sadrzi_list = false;
    int dubina_podstabla = 0;
    int dubina_cvora = 0;
    int cvor_iznad = -1;
};

CvorInfo cvorovi[MAXN];
int max_dubina_podstabla;
int index_lika_sa_kul_stablom_jej;

pair<int, bool> dfs2(int x, int prev, int d, int trazeni)
{
    if (prev == -1) {
        max_dubina_podstabla = INT_MIN;
        index_lika_sa_kul_stablom_jej = -1;
    }
    int max_dubina = d;
    bool sadrzi_list = (x == trazeni);

    for (auto a: g[x])
    {
        if (a != prev)
        {
            auto uv = dfs2(a, x, d + 1, trazeni);
            max_dubina = max(max_dubina, uv.first);
            sadrzi_list |= uv.second;
        }
    }
    max_dubina = max_dubina - d + 1;
    cvorovi[x].dubina_cvora = d;
    cvorovi[x].cvor_iznad = prev;
    cvorovi[x].sadrzi_list = sadrzi_list;
    cvorovi[x].dubina_podstabla = max_dubina;

    if (max_dubina > max_dubina_podstabla && !sadrzi_list)
    {
        max_dubina_podstabla = max_dubina;
        index_lika_sa_kul_stablom_jej = x;
    }

    return {d, sadrzi_list};
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

#ifdef MAKSBODOVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif // MAKSBODOVA

    int t;
    cin >> t;
    while(t--)
    {
        int n;
        cin >> n;
        int k;
        cin >> k;

        for (int i = 0; i < MAXN; i++)
        {
            g[i].clear();
            cvorovi[i] = {};
        }

        for (int i = 0; i < n-1; i++)
        {
            int u, v;
            cin >> u >> v;
            g[u].insert(v);
            g[v].insert(u);
        }
        /*
        for (int i = 1; i <= n; i++) {
            for (auto x: g[i]) {
                cout << x << " ";
            }
            cout << endl;
        }
        */
        int a, b;

        dfs1(1, -1, 0);
        a = najdalji;

        dfs1(a, -1, 0);
        b = najdalji;

        //cout << a << " " << b << endl;

        int root = a;
        int kraj = b;
        //cout << najdalji << endl;

        dfs2(root, -1, 0, kraj);
        //cout << root << " " << kraj << endl;

        for (int i = 0; i < k; i++)
        {
            int x = index_lika_sa_kul_stablom_jej;
            if (x != -1)
            {
                int prev = cvorovi[x].cvor_iznad;
                //cout << root << " " << kraj << endl;
                //cout << x << " " << prev << endl;
                g[prev].erase(x);
                g[x].erase(prev);

                g[kraj].insert(x);
                g[x].insert(kraj);

                dfs1(root, -1, 0);
                kraj = najdalji;
                //cout << najdalji << endl;
                dfs2(root, -1, 0, kraj);
            }
            else {
                break;
            }
        }
       // cout << endl;

        //if (x == -1)
        cout << cvorovi[kraj].dubina_cvora << '\n';
    }

    return 0;
}