#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define sp ' '
#define en '\n'
#define smin(a, b) a = min(a, b)
#define smax(a, b) a = max(a, b)
using namespace std;
const int N = 1e5 + 5;
const int inf = 1e9;
int n;
struct Segtree {
    int st[N];
    void Reset (int n) {
        for (int i = 1; i < 4 * n; i++) st[i] = 0;
    }
    void Set(int node, int l, int r, int x, int y) {
        if (l == r) {
            st[node] = y;
            return;
        }
        int mid = l + r >> 1;
        if (x <= mid) Set(2 * node, l, mid, x, y);
        else Set(2 * node + 1, mid + 1, r, x, y);
        st[node] = st[2 * node] + st[2 * node + 1];
    }
    int Get(int node, int l, int r, int ql, int qr) {
        if (r < ql || qr < l) return 0;
        if (ql <= l && r <= qr) return st[node];
        int mid = l + r >> 1;
        return Get(2 * node, l, mid, ql, qr) + Get(2 * node + 1, mid + 1, r, ql, qr);
    }
    int Levo(int node, int l, int r, int x) {
        if (l == r) return l;
        int mid = l + r >> 1;
        if (x > mid && Get(1, 0, n + 1, mid + 1, min(x, r)) != min(x, r) - mid)
            return Levo(1, mid + 1, r, x);
        return Levo(1, l, mid, x);
    }
    int Desno(int node, int l, int r, int x) {
        if (l == r) return l;
        int mid = l + r >> 1;
        if (x <= mid && Get(1, 0, n + 1, max(l, x), mid) != mid - max(l, x) + 1)
            return Desno(2 * node, l, mid, x);
        return Desno(2 * node + 1, mid + 1, r, x);
    }
}seg[20];
int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    for (int i = 0; i < 20; i++) seg[i].Reset(n + 2);
    for (int i = 0; i < 20; i++) {
        seg[i].Set(1, 0, n + 1, 0, 0);
        seg[i].Set(1, 0, n + 1, n + 1, 0);
    }
    int MX = 0;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        for (int j = 0; j < 20; j++) {
            if ((1 << j) & a[i]) seg[j].Set(1, 0, n + 1, i, 1);
            else seg[j].Set(1, 0, n + 1, i, 0);
        }
        smax(MX, a[i]);
    }
    int q; cin >> q;
    while (q--) {
        int ty, i; cin >> ty >> i;
        if (ty == 1) {
            cin >> a[i];
            for (int j = 0; j < 20; j++) {
                if ((1 << j) & a[i]) seg[j].Set(1, 0, n + 1, i, 1);
                else seg[j].Set(1, 0, n + 1, i, 0);
            }
            smax(MX, a[i]);
            continue;
        }
        vector<int> l(20), r(20);
        vector<pair<int, int>> v;
        for (int j = 0; j < 20; j++) {
            int lev = seg[j].Levo(1, 0, n + 1, i);
            if (lev == 0) l[j] = inf;
            else l[j] = i - lev;
            int des = seg[j].Desno(1, 0, n + 1, i);
            if (des == n + 1) r[j] = inf;
            else r[j] = des - i;
            v.push_back({l[j], j});
        }
        sort(v.begin(), v.end());
        set<pair<int, int>> st;
        for (int j = 0; j < 20; j++) st.insert({-r[j], j});
        int ans = inf;
        for (int i = 0; i < 20; i++) {
            if (v[i].first == inf) break;
            st.erase({-r[v[i].second], v[i].second});
            auto parc = *(st.begin());
            if (-parc.first != inf) {
                int mn = min(v[i].first, -parc.first);
                int mx = max(v[i].first, -parc.first);
                smin(ans, 2 * mn + mx);
            }
        }
        if (ans == inf) ans = -1;
        cout << ans << en;
    }
    return 0;
}