#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned u;

#define INF LONG_LONG_MAX
#define MOD (1000000007)
#define PI arccos(-1)

#define pll pair<long long, long long>
#define mp make_pair

#define vll vector<ll>
#define vb vector<bool>
#define vs vector<string>
#define vp vector<pll>
#define pb push_back
#define all(v) v.begin(), v.end()
#define print_vect(v) for (auto it : v) cout << it << " ";

#define pq priority_queue<ll>
#define pqg priority_queue<ll, vll, greater<ll>>
#define set set<ll>
#define mset multiset<ll>
#define queue queue<ll>

ll add(ll a, ll b) { a += b; return a >= MOD ? a - MOD : a; }
ll sub(ll a, ll b) { a -= b; return a < 0 ? a + MOD : a; }
ll mul(ll a, ll b) { return (long long)(a) * (long long)(b) % MOD; }

void sadd(ll &a, ll b) { a = add(a, b); }
void ssub(ll &a, ll b) { a = sub(a, b); }
void smul(ll &a, ll b) { a = mul(a, b); }

ll nzs(ll a, ll b){
    return (a / __gcd(a, b)) * b;
}

const ll N = 1510;
ll z;
ll n, m, k;
vector<vll> a(N, vll(N));
vector<vll> minimum(N, vll(N, INF));
vector<vll> maximum(N, vll(N, 0));

void rekonstruisi(ll x, ll y){
    ll i = x;
    ll j = y;
    stack<char> stek;
    ll trenutno = maximum[i][j];
    while(i > 1 || j > 1){
        if(j > 1 && maximum[i][j - 1] <= trenutno){
            stek.push('D');
            trenutno = maximum[i][j - 1];
            j--;
        }
        if(i > 1 && maximum[i - 1][j] <= trenutno){
            stek.push('S');
            trenutno = maximum[i - 1][j];
            i--;
        }
    }
    while(!stek.empty()){
        cout << stek.top();
        stek.pop();
    }
    i = x;
    j = y;
    trenutno = minimum[i][j];
    while(i < n || j < m){
        if(j < m && minimum[i][j + 1] <= trenutno){
            cout << 'D';
            trenutno = minimum[i][j + 1];
            j++;
        }
        if(i < n && minimum[i + 1][j] <= trenutno){
            cout << 'S';
            trenutno = minimum[i + 1][j];
            i++;
        }
    }
    cout << "\n";
}

void maximumi(){
    for(ll i = 1 ; i <= n ; i++){
        for(ll j = 1 ; j <= m ; j++){
            maximum[i][j] = max(maximum[i][j - 1], maximum[i - 1][j]) + a[i][j];
        }
    }
}

void minimumi(){
    for(ll i = n ; i > 0 ; i--){
        for(ll j = m ; j > 0 ; j--){
            if(i == n && j == m)
                minimum[i][j] = a[i][j];
            else
                minimum[i][j] = min(minimum[i][j + 1], minimum[i + 1][j]) + a[i][j];
        }
    }
}

void solve(){
    cin >> n >> m >> k;
    for(ll i = 0 ; i < n ; i++){
        maximum[i][m + 1] = 0;
        minimum[i][m + 1] = INF;
    }
    for(ll i = 0 ; i < m ; i++){
        minimum[n + 1][i] = INF;
         maximum[n + 1][i] = 0;
    }
    for(ll i = 1 ; i <= n ; i++){
        string s;
        cin >> s;
        for(ll j = 1 ; j <= m ; j++){
            maximum[i][j] = 0;
            minimum[i][j] = INF;
            a[i][j] = (s[j - 1] == '1');
        }
    }
    maximumi();
    minimumi();
    ll x = -1, y = -1;
    for(ll i = 1 ; i <= n ; i++){
        for(ll j = 1 ; j <= m ; j++){
            if(maximum[i][j] + minimum[i][j] - a[i][j] == k){
                x = i;
                y = j;
            }
        }
    }
    if(x == -1 || y == -1){
        cout << "NE\n";
        return;
    }
    cout << "DA\n";
    if(z)
        rekonstruisi(x, y);
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    ll tt;
    cin >> tt >> z;
    while(tt--){
        solve();
    }
    return 0;
}