#include <bits/stdc++.h>

#define pb push_back
#define MAXN 3010

using namespace std;

vector<int> tree[MAXN];
vector<bool> diam;
vector<int> sol(MAXN);

pair<int, int> najdalji(int u, int p) {

    int ans = u, d = 0;
    for(int v: tree[u]) {
        if(v != p && !diam[v]) {
            auto k = najdalji(v, u);
            if(k.second > d) {
                d = k.second;
                ans = k.first;
            }
        }
    }
    sol[u] = ans;
    return {ans, d + 1};
}

void obelezi(int u, int p, int r) {

    diam[u] = true;
    for(int v: tree[u])
        if(v != p && sol[v] == r)
            obelezi(v, u, r);
}

tuple<int, int, int> di(int u, int p) {

    int l = najdalji(u, p).first;
    auto k = najdalji(l, -1);
    int r = k.first;

    if(p == -1)
        obelezi(l, -1, r);
    return {k.second, l, r};
}

void solve() {

    int n, k;
    cin >> n >> k;
    for(int i = 0; i < n; i++)
        tree[i].clear();

    for(int i = 0; i < n - 1; i++) {
        int u, v;
        cin >> u >> v;
        u--; v--;

        tree[u].pb(v);
        tree[v].pb(u);
    }

    for(int j = 0; j < k; j++) {
        int temp, l, r;
        diam = vector<bool>(n);
        tie(temp, l, r) = di(0, -1);

        for(int i = 0; i < n; i++) {
            int mx = -1, a, b, c, d;
            if(diam[i]) {
                for(int v: tree[i]) {
                    if(!diam[v]) {
                        int m, x, y;
                        tie(m, x, y) = di(v, i);

                        if(m > mx) {
                            mx = m;
                            a = x;
                            b = y;
                            c = v;
                            d = i;
                        }
                    }
                }
            }
            if(mx == -1)
                continue;

            for(int i = 0; i < tree[c].size(); i++)
                if(tree[c][i] == d)
                    tree[c].erase(tree[c].begin() + i);
            for(int i = 0; i < tree[d].size(); i++)
                if(tree[d][i] == c)
                    tree[d].erase(tree[d].begin() + i);
            tree[l].pb(a);
            tree[a].pb(l);
        }
    }

    int temp, l, r;
    diam = vector<bool>(n);
    tie(temp, l, r) = di(0, -1);
    cout << temp - 1 << endl;
}

/*
1
5 1
1 4
3 4
2 4
5 2
*/

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while(t--)
        solve();
    return 0;
}