#include <bits/stdc++.h>

using namespace std;

#define ll long long
const int INF=1e9,MOD=998244353;
const ll LINF=1e18;
#define fi first
#define se second
#define pii pair<int,int>
#define pll pair<ll,ll>
#define mid ((l+r)/2)
#define sz(a) (int((a).size()))
#define all(a) a.begin(),a.end()
#define endl "\n"
#define pb push_back

void PRINT(int x) {cerr << x;}
void PRINT(ll x) {cerr << x;}
void PRINT(double x) {cerr << x;}
void PRINT(char x) {cerr << '\'' << x << '\'';}
void PRINT(string x) {cerr << '\"' << x << '\"';}
void PRINT(bool x) {cerr << (x ? "true" : "false");}

template<typename T,typename V>
void PRINT(pair<T,V>& x){
    cerr<<"{";
    PRINT(x.fi);
    cerr<<",";
    PRINT(x.se);
    cerr<<"}";
}
template<typename T>
void PRINT(T &x){
    int id=0;
    cerr<<"{";
    for(auto _i:x){
        cerr<<(id++ ? "," : "");
        PRINT(_i);
    }
    cerr<<"}";
}
void _PRINT(){
    cerr<<"]\n";
}
template<typename Head,typename... Tail>
void _PRINT(Head h,Tail... t){
    PRINT(h);
    if(sizeof...(t)) cerr<<", ";
    _PRINT(t...);
}

#define Debug(x...) cerr<<"["<<#x<<"]=["; _PRINT(x)

const int MAXC=2e5+10;

set<int> adj[MAXC];
int in[MAXC],d1[MAXC],dC[MAXC];
ll w1[MAXC],wC[MAXC];
vector<pii> v1,v2;
set<int> pret[MAXC];
int C;

vector<int> TopoSort(){
    deque<int> deg0;
    for(int node=1;node<=C;node++){
        in[node]=sz(pret[node]);
        if(!in[node]) deg0.pb(node);
    }
    vector<int> ret;
    while(!deg0.empty()){
        int node=deg0.front(); deg0.pop_front();
        ret.pb(node);
        for(int x:adj[node]){
            in[x]--;
            if(!in[x]) deg0.pb(x);
        }
    }
    return ret;
}

void Obrni(){
    for(int i=1;i<=C;i++){
        swap(pret[i],adj[i]);
    }
}

void Solve(){
    int N,M,P; cin>>N>>M>>P;
    map<pii,int> node_polja;
    int res=0;
    set<pii> s1,s2;
    node_polja[{1,1}]=1; C++;
    s1.insert({1,1}); s2.insert({1,1});
    for(int i=1;i<=P;i++){
        int x,y; cin>>x>>y;
        if((x!=1 || y!=1) && (x!=N || y!=M)){
            node_polja[{x,y}]=C+1; C++;
            s1.insert({x,y}); s2.insert({y,x});
        }
        else res++;
    }
    node_polja[{N,M}]=C+1; C++;
    s1.insert({N,M}); s2.insert({M,N});
    for(auto p:s1) v1.pb(p);
    for(auto p:s2) v2.pb(p);

    for(auto p:v2){
        swap(p.fi,p.se);
        int n=node_polja[p];
        auto it1=s1.lower_bound({p.fi+1,p.se});
        if(it1!=s1.end()){
            pii p1=*(it1);
            int n1=node_polja[p1];
            adj[n].insert(n1);
            pret[n1].insert(n);
        }
        s1.erase(s1.find(p));
    }
    for(auto p:v1){
        int n=node_polja[p];
        auto it2=s2.lower_bound({p.se+1,p.fi});
        if(it2!=s2.end()){
            pii p2=*(it2); swap(p2.fi,p2.se);
            int n2=node_polja[p2];
            adj[n].insert(n2);
            pret[n2].insert(n);
        }
        s2.erase(s2.find({p.se,p.fi}));
    }

    Obrni();
    vector<int> topo2=TopoSort();

    for(int node:topo2){
        for(int par:pret[node]) dC[node]=max(dC[node],dC[par]+1);
        for(int par:pret[node]){
            if(dC[par]==dC[node]-1) wC[node]+=wC[par];
        }
    }

    Obrni();
    vector<int> topo1=TopoSort();

    for(int node:topo1){
        for(int par:pret[node]) d1[node]=max(d1[node],d1[par]+1);
        for(int par:pret[node]){
            if(d1[par]==d1[node]-1) w1[node]+=w1[par];
        }
    }

    for(int node=2;node<C;node++){
        if(d1[node]+dC[node]==d1[C]){
            res+=(w1[node]*wC[node]==w1[C]);
        }
    }

    cout<<res<<endl;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t; t=1;
    cin>>t;
    while(t--){
        Solve();
    }
    return 0;
}